diff -Naur -X ./exclude vnc_unixsrc.orig/vncviewer/rfbproto.c vnc_unixsrc/vncviewer/rfbproto.c
--- vnc_unixsrc.orig/vncviewer/rfbproto.c	2008-09-05 19:51:24.000000000 -0400
+++ vnc_unixsrc/vncviewer/rfbproto.c	2010-04-17 22:34:38.000000000 -0400
@@ -818,44 +2046,84 @@
     }
 
     encs[se->nEncodings++] = Swap32IfLE(rfbEncodingCopyRect);
-    encs[se->nEncodings++] = Swap32IfLE(rfbEncodingTight);
+    if (!dsm) encs[se->nEncodings++] = Swap32IfLE(rfbEncodingTight);
+    encs[se->nEncodings++] = Swap32IfLE(rfbEncodingZRLE);
+    encs[se->nEncodings++] = Swap32IfLE(rfbEncodingZYWRLE);
     encs[se->nEncodings++] = Swap32IfLE(rfbEncodingHextile);
-    encs[se->nEncodings++] = Swap32IfLE(rfbEncodingZlib);
-    encs[se->nEncodings++] = Swap32IfLE(rfbEncodingCoRRE);
+    if (!dsm) encs[se->nEncodings++] = Swap32IfLE(rfbEncodingZlib);
+    if (!dsm) encs[se->nEncodings++] = Swap32IfLE(rfbEncodingCoRRE);
     encs[se->nEncodings++] = Swap32IfLE(rfbEncodingRRE);
 
-    if (appData.compressLevel >= 0 && appData.compressLevel <= 9) {
-      encs[se->nEncodings++] = Swap32IfLE(appData.compressLevel +
-					  rfbEncodingCompressLevel0);
-    } else if (!tunnelSpecified) {
-      /* If -tunnel option was provided, we assume that server machine is
-	 not in the local network so we use default compression level for
-	 tight encoding instead of fast compression. Thus we are
-	 requesting level 1 compression only if tunneling is not used. */
-      encs[se->nEncodings++] = Swap32IfLE(rfbEncodingCompressLevel1);
-    }
-
-    if (appData.enableJPEG) {
-      if (appData.qualityLevel < 0 || appData.qualityLevel > 9)
-	appData.qualityLevel = 5;
-      encs[se->nEncodings++] = Swap32IfLE(appData.qualityLevel +
-					  rfbEncodingQualityLevel0);
+    if (!dsm && appData.compressLevel >= 0 && appData.compressLevel <= 9) {
+	encs[se->nEncodings++] = Swap32IfLE(appData.compressLevel + rfbEncodingCompressLevel0);
+    } else {
+	/*
+         * OUT OF DATE: If -tunnel option was provided, we assume that server machine is
+	 * not in the local network so we use default compression level for
+	 * tight encoding instead of fast compression. Thus we are
+	 * requesting level 1 compression only if tunneling is not used.
+         */
+	appData.compressLevel = guess_compresslevel();
+	if (clmsg++ == 0) fprintf(stderr, "guessed: -compresslevel %d\n", appData.compressLevel);
+	encs[se->nEncodings++] = Swap32IfLE(appData.compressLevel + rfbEncodingCompressLevel0);
+    }
+
+    if (!dsm && appData.enableJPEG) {
+	if (appData.qualityLevel < 0 || appData.qualityLevel > tQLmax) {
+		appData.qualityLevel = guess_qualitylevel();
+		if (qlmsg++ == 0) fprintf(stderr, "guessed: -qualitylevel  %d\n", appData.qualityLevel);
+	}
+
+#ifdef TURBOVNC
+    requestSubsampLevel = True;
+    tQL = appData.qualityLevel / 10;
+    if (tQL < 0) tQL = 1;
+    if (tQL > 9) tQL = 9;
+    encs[se->nEncodings++] = Swap32IfLE(tQL + rfbEncodingQualityLevel0);
+    encs[se->nEncodings++] = Swap32IfLE(appData.qualityLevel + rfbJpegQualityLevel1 - 1);
+    if (se->nEncodings < MAX_ENCODINGS && requestSubsampLevel) {
+	if (appData.subsampLevel < 0 || appData.subsampLevel > TVNC_SAMPOPT - 1) {
+		appData.subsampLevel = TVNC_1X;
+	}
+	encs[se->nEncodings++] = Swap32IfLE(appData.subsampLevel + rfbJpegSubsamp1X);
+    }
+#else
+    encs[se->nEncodings++] = Swap32IfLE(appData.qualityLevel + rfbEncodingQualityLevel0);
+#endif
+
     }
 
     if (appData.useRemoteCursor) {
       encs[se->nEncodings++] = Swap32IfLE(rfbEncodingXCursor);
-      encs[se->nEncodings++] = Swap32IfLE(rfbEncodingRichCursor);
+      if (!appData.useX11Cursor) {
+      	encs[se->nEncodings++] = Swap32IfLE(rfbEncodingRichCursor);
+      }
       encs[se->nEncodings++] = Swap32IfLE(rfbEncodingPointerPos);
     }
 
     encs[se->nEncodings++] = Swap32IfLE(rfbEncodingLastRect);
+    encs[se->nEncodings++] = Swap32IfLE(rfbEncodingNewFBSize);
   }
 
   len = sz_rfbSetEncodingsMsg + se->nEncodings * 4;
 
-  se->nEncodings = Swap16IfLE(se->nEncodings);
+	if (!appData.ultraDSM) {
+		se->nEncodings = Swap16IfLE(se->nEncodings);
 
-  if (!WriteExact(rfbsock, buf, len)) return False;
+		if (!WriteExact(rfbsock, buf, len)) return False;
+	} else {
+		/* for UltraVNC encryption DSM we have to send each encoding separately (why?) */
+		int i, errs = 0, nenc = se->nEncodings;
+		
+		se->nEncodings = Swap16IfLE(se->nEncodings);
+
+		currentMsg = rfbSetEncodings;
+		if (!WriteExact(rfbsock, buf, sz_rfbSetEncodingsMsg)) errs++;
+		for (i=0; i < nenc; i++) {
+			if (!WriteExact(rfbsock, (char *)&encs[i], sizeof(CARD32))) errs++;
+		}
+		if (errs) return False;
+	}
 
   return True;
 }
@@ -868,31 +2136,86 @@
 Bool
 SendIncrementalFramebufferUpdateRequest()
 {
-  return SendFramebufferUpdateRequest(0, 0, si.framebufferWidth,
-				      si.framebufferHeight, True);
+	return SendFramebufferUpdateRequest(0, 0, si.framebufferWidth,
+	    si.framebufferHeight, True);
 }
 
+time_t last_filexfer = 0;
+int delay_filexfer = 3;
+extern void CheckFileXfer(void);
+extern int rfbsock_is_ready(void);
+
+
+static int dyn = -1;
+extern int filexfer_sock;
+extern int filexfer_listen;
 
 /*
  * SendFramebufferUpdateRequest.
  */
-
 Bool
 SendFramebufferUpdateRequest(int x, int y, int w, int h, Bool incremental)
 {
-  rfbFramebufferUpdateRequestMsg fur;
+	rfbFramebufferUpdateRequestMsg fur;
+	static int db = -1;
 
-  fur.type = rfbFramebufferUpdateRequest;
-  fur.incremental = incremental ? 1 : 0;
-  fur.x = Swap16IfLE(x);
-  fur.y = Swap16IfLE(y);
-  fur.w = Swap16IfLE(w);
-  fur.h = Swap16IfLE(h);
+	if (db < 0) {
+		if (getenv("SSVNC_DEBUG_RECTS")) {
+			db = atoi(getenv("SSVNC_DEBUG_RECTS"));
+		} else {
+			db = 0;
+		}
+	}
 
-  if (!WriteExact(rfbsock, (char *)&fur, sz_rfbFramebufferUpdateRequestMsg))
-    return False;
+	if (db) fprintf(stderr, "SendFramebufferUpdateRequest(%d, %d, %d, %d, incremental=%d)\n", x, y, w, h, (int) incremental);
 
-  return True;
+	if (dyn < 0) {
+		struct stat sb;
+		if (getenv("USER") && !strcmp(getenv("USER"), "runge")) {
+			if (stat("/tmp/nodyn", &sb) == 0) {
+				putenv("NOFTFBUPDATES=1");
+				unlink("/tmp/nodyn");
+			}
+		}
+		if (getenv("NOFTFBUPDATES")) {
+			dyn = 0;
+		} else {
+			dyn = 1;
+		}
+	}
+
+	if (appData.fileActive && filexfer_sock >= 0) {
+		static int first = 1;
+		if (first) {
+			fprintf(stderr, "SFU: dynamic fb updates during filexfer: %d\n", dyn);
+			first = 0;
+		}
+if (db > 2 || 0) fprintf(stderr, "A sfur: %d %d %d %d d_last: %d\n", x, y, w, h, (int) (time(NULL) - last_filexfer));
+		if (!dyn || time(NULL) < last_filexfer + delay_filexfer) {
+			return True;
+		}
+	}
+if (db > 1) fprintf(stderr, "B sfur: %d %d %d %d\n", x, y, w, h);
+
+	fur.type = rfbFramebufferUpdateRequest;
+	fur.incremental = incremental ? 1 : 0;
+	fur.x = Swap16IfLE(x);
+	fur.y = Swap16IfLE(y);
+	fur.w = Swap16IfLE(w);
+	fur.h = Swap16IfLE(h);
+
+	if (incremental) {
+		sent_FBU = 1;
+	} else {
+		sent_FBU = 2;
+	}
+
+	currentMsg = rfbFramebufferUpdateRequest;
+	if (!WriteExact(rfbsock, (char *)&fur, sz_rfbFramebufferUpdateRequestMsg)) {
+		return False;
+	}
+
+	return True;
 }
 
 
@@ -903,19 +2226,38 @@
 Bool
 SendPointerEvent(int x, int y, int buttonMask)
 {
-  rfbPointerEventMsg pe;
+	rfbPointerEventMsg pe;
+
+	if (appData.fileActive) {
+		if (!dyn || time(NULL) < last_filexfer + delay_filexfer) {
+#if 0
+			fprintf(stderr, "skip SendPointerEvent: %d - %d\n", last_filexfer, time(NULL));
+#endif
+			return True;
+		}
+	}
 
-  pe.type = rfbPointerEvent;
-  pe.buttonMask = buttonMask;
-  if (x < 0) x = 0;
-  if (y < 0) y = 0;
-
-  if (!appData.useX11Cursor)
-    SoftCursorMove(x, y);
-
-  pe.x = Swap16IfLE(x);
-  pe.y = Swap16IfLE(y);
-  return WriteExact(rfbsock, (char *)&pe, sz_rfbPointerEventMsg);
+	pe.type = rfbPointerEvent;
+	pe.buttonMask = buttonMask;
+
+	if (scale_factor_x > 0.0 && scale_factor_x != 1.0) {
+		x /= scale_factor_x;
+	}
+	if (scale_factor_y > 0.0 && scale_factor_y != 1.0) {
+		y /= scale_factor_y;
+	}
+
+	if (x < 0) x = 0;
+	if (y < 0) y = 0;
+
+	if (!appData.useX11Cursor) {
+		SoftCursorMove(x, y);
+	}
+
+	pe.x = Swap16IfLE(x);
+	pe.y = Swap16IfLE(y);
+	currentMsg = rfbPointerEvent;
+	return WriteExact(rfbsock, (char *)&pe, sz_rfbPointerEventMsg);
 }
 
 
@@ -926,12 +2268,22 @@
 Bool
 SendKeyEvent(CARD32 key, Bool down)
 {
-  rfbKeyEventMsg ke;
+	rfbKeyEventMsg ke;
+
+	if (appData.fileActive) {
+		if (!dyn || time(NULL) < last_filexfer + delay_filexfer) {
+#if 0
+			fprintf(stderr, "skip SendPointerEvent: %d - %d\n", last_filexfer, time(NULL));
+#endif
+			return True;
+		}
+	}
 
-  ke.type = rfbKeyEvent;
-  ke.down = down ? 1 : 0;
-  ke.key = Swap32IfLE(key);
-  return WriteExact(rfbsock, (char *)&ke, sz_rfbKeyEventMsg);
+	ke.type = rfbKeyEvent;
+	ke.down = down ? 1 : 0;
+	ke.key = Swap32IfLE(key);
+	currentMsg = rfbKeyEvent;
+	return WriteExact(rfbsock, (char *)&ke, sz_rfbKeyEventMsg);
 }
 
 
